DECLARE SUB WriteDate (Date AS ANY)
DECLARE SUB WriteHMS (TimeIn AS DOUBLE, n AS INTEGER)
DECLARE SUB WriteDMS (AngleIn AS DOUBLE, n AS INTEGER)
DECLARE SUB ReadDate (s AS STRING, Date AS ANY)
DECLARE SUB MoonPhysEphemeris (T AS DOUBLE, SGeo AS ANY, SSun AS ANY, Obl AS DOUBLE, NutLon AS DOUBLE, NutObl AS DOUBLE, MoonPhysData AS ANY)
DECLARE SUB MoonPos (T AS DOUBLE, s AS ANY)
DECLARE SUB NutationConst (T AS DOUBLE, NutLon AS DOUBLE, NutObl AS DOUBLE)
DECLARE SUB ObserverCoord (Phi AS DOUBLE, Height AS DOUBLE, RhoCosPhi AS DOUBLE, RhoSinPhi AS DOUBLE)
DECLARE SUB DoParallaxHiAlt (sinParallax AS DOUBLE, LST AS DOUBLE, RhoCosPhi AS DOUBLE, RhoSinPhi AS DOUBLE, RA AS DOUBLE, Decl AS DOUBLE, SD AS DOUBLE)
DECLARE SUB InitPlanetaryTerms (FilePath AS STRING)
DECLARE SUB ReadPlanetaryTerms (Planet AS INTEGER)
DECLARE SUB FreePlanetaryTerms ()
DECLARE SUB RiseSet (T AS DOUBLE, DeltaT AS DOUBLE, RA1 AS DOUBLE, Decl1 AS DOUBLE, RA2 AS DOUBLE, Decl2 AS DOUBLE, RA3 AS DOUBLE, Decl3 AS DOUBLE, Height0 AS DOUBLE, Lon AS DOUBLE, Lat AS DOUBLE, RISE AS DOUBLE, Transit AS DOUBLE, Setting AS DOUBLE _
, Flags AS INTEGER)
DECLARE SUB SunPosHi (T AS DOUBLE, RefFrame AS INTEGER, s AS ANY)
DECLARE SUB EclToEqu (l AS DOUBLE, b AS DOUBLE, Obl AS DOUBLE, RA AS DOUBLE, Decl AS DOUBLE)
DECLARE SUB EquToHor (RA AS DOUBLE, Decl AS DOUBLE, LST AS DOUBLE, ObsLat AS DOUBLE, Az AS DOUBLE, Alt AS DOUBLE)
'****************************************************************************
'*
'*                  Copyright (c) 1991-1994 by Jeffrey Sax
'*                            All rights reserved
'*                        Published and Distributed by
'*                           Willmann-Bell, Inc.
'*                             P.O. Box 35025
'*                        Richmond, Virginia 23235
'*                Voice (804) 320-7016 FAX (804) 272-5920
'*
'*
'*                NOTICE TO COMMERCIAL SOFTWARE DEVELOPERS
'*
'*        Prior to distributing software incorporating this code
'*        you MUST write Willmann-Bell, Inc. at the above address
'*        for validation of your book's (Astronomical Algorithms
'*        by Jean Meeus) and software Serial Numbers.  No additional
'*        fees will be required BUT you MUST have the following
'*        notice at the start of your program(s):
'*
'*                    This program contains code
'*              Copyright (c) 1991-1994 by Jeffrey Sax
'*              and Distributed by Willmann-Bell, Inc.
'*                         Serial 076358
'*
'****************************************************************************
'* Name:   Moon
'* Module: MOON.BAS
'* Type:   Main Program
'* Purpose: calculate everything about the Moon
'* Version 2.1
'* Last modified: January 3, 1994
'****************************************************************************

DECLARE SUB Header ()
DECLARE SUB InputData ()


'$INCLUDE: 'a:\aafull.bi'


DIM SHARED Date AS TDATE
DIM SHARED ObsLon AS DOUBLE, ObsLat AS DOUBLE, Height AS DOUBLE
DIM SHARED TimeZone AS DOUBLE, RhoCosPhi AS DOUBLE, RhoSinPhi AS DOUBLE
COMMON SHARED H%, m%     ' $$$$$  use to share with IO.BAS:readHMS

DIM T AS DOUBLE, DTOfUT AS DOUBLE, DeltaT AS DOUBLE
DIM Obl AS DOUBLE, NutLon AS DOUBLE, NutObl AS DOUBLE, LAST AS DOUBLE
DIM s AS TSVECTOR, S2 AS TSVECTOR, SSun AS TSVECTOR
DIM MoonParallax AS DOUBLE, SemiDiameter AS DOUBLE
DIM RA AS DOUBLE, Decl AS DOUBLE
DIM RA1 AS DOUBLE, RA2 AS DOUBLE, RA3 AS DOUBLE
DIM Decl1 AS DOUBLE, Decl2 AS DOUBLE, Decl3 AS DOUBLE
DIM Az AS DOUBLE, Alt AS DOUBLE, dAlt AS DOUBLE
DIM RISE AS DOUBLE, Transit AS DOUBLE, Setting AS DOUBLE
DIM RiseSetFlags AS INTEGER
DIM PhysData AS TMOONPHYSDATA

Header
 

PRINT "Allow Program to Run, Date and Hour Updates Automatically"
PRINT "Please Do not Enter Incorrect Dates"
PRINT "REQUIRED:  Hit any key for printout": PRINT


restart:           ' $$$$$  added below section from InputDate

IF INKEY$ > "" THEN GOSUB printouts

CALL ReadDate("Enter date ", Date)
Date.dd = Date.dd + ReadHMS("Enter time ") / pi2
PRINT

  IF firsttime = 1 THEN GOTO bypass


PRINT "Astoria Ore.  124  and  46.3 degrees    time zone 8"
ObsLon = ReadDMS("Enter longitude (East is minus) ")
ObsLat = ReadDMS("Enter latitude ")
TimeZone = ReadReal("Enter time zone (UT - LT) in hours ") / 24
Height = ReadReal("Enter height above sea level in meters ")

bypass:
firsttime = 1

' Preliminary calculations
T = JDToT(CalendarToJD(Date) + TimeZone)   ' Yes thats a variable name
DeltaT = ApproxDeltaT(T)
DTOfUT = T + DeltaT * secToT
Obl = Obliquity(T)
CALL NutationConst(T, NutLon, NutObl)
LAST = SiderealTime(T) + NutLon * COS(Obl) - ObsLon
CALL ObserverCoord(ObsLat, Height, RhoCosPhi, RhoSinPhi)

PRINT "Position of the Moon on ";
CALL WriteDate(Date)
PRINT " at ";
CALL WriteHMS((Date.dd - INT(Date.dd)) * pi2, 4)

PRINT
PRINT USING "JD = #######.#####, T = #.############"; CalendarToJD(Date); T
PRINT "Longitude = ";
CALL WriteDMS(ObsLon, 4)
PRINT ", Latitude = ";
CALL WriteDMS(ObsLat, 4)
PRINT ", Height above sea level :"; INT(Height); "m"

' Calculate the position of the Sun
CALL InitPlanetaryTerms("")

'  IF planetfile > 0 THEN
'                  GOTO bypass1 '$$$$$
'                  END IF

CALL ReadPlanetaryTerms(3)

bypass1:                       '$$$$$$

CALL SunPosHi(T, EPDATE, SSun)
CALL FreePlanetaryTerms

' Main Calculations
CALL MoonPos(T, s)
MoonParallax = asin(EarthRadius / s.r)
SemiDiameter = MoonSemiDiameter(s.r)
PRINT "True ecliptical coordinates : lambda = ";
CALL WriteDMS(s.l + NutLon, 5)
PRINT ", Beta = ";
CALL WriteDMS(s.b, 4)
PRINT

PRINT "Parallax = ";
CALL WriteDMS(MoonParallax, 7)
PRINT ", Geocentric angular diameter = ";
CALL WriteDMS(2 * SemiDiameter * SToR, 4)
       
        DistRatio1 = SemiDiameter     'Distance ratio    $$$$$

PRINT
PRINT USING "Earth-Moon distance = ######.#km = ######.#mi"; s.r; s.r / 1.60934

CALL EclToEqu(s.l, s.b, Obl, RA, Decl)
PRINT "Mean equatorial coordinates :  = ";
CALL WriteHMS(RA, 5)
PRINT ",  = ";
CALL WriteDMS(Decl, 4)
PRINT

CALL EclToEqu(s.l + NutLon, s.b, Obl + NutObl, RA, Decl)
PRINT "True equatorial coordinates :  = ";
CALL WriteHMS(RA, 5)
PRINT ",  = ";
CALL WriteDMS(Decl, 4)
PRINT

CALL DoParallaxHiAlt(SIN(MoonParallax), LAST, RhoCosPhi, RhoSinPhi, RA, Decl, SemiDiameter)
PRINT "Topocentric coordinates :  = ";
CALL WriteHMS(RA, 5)                    ' REQUIRED FOR RIGHT ASCENSION
PRINT ",  = ";             ' MAY WANT TO USE HORIZONTAL COORDINATES INSTEAD
CALL WriteDMS(Decl, 4)                  ' REQUIRED FOR DECLINATION
PRINT

' PRINT "$$$$$ RA "; RA      '  WILL NOT PRINT OUT CORRECTLY FROM HERE
' PRINT "$$$$$ Decl "; Decl

PRINT "Topocentric angular diameter = ";
CALL WriteDMS(2 * SemiDiameter * SToR, 4)
       
        DistRatio2 = SemiDiameter     ' Distance ratio    $$$$$
PRINT
CALL EquToHor(RA, Decl, LAST, ObsLat, Az, Alt)
PRINT "Horizontal coordinates:   Azimuth (degs.east from north) = ";
CALL WriteDMS(Az, 4)
PRINT "                         Altitude degs.above horizon (h) = ";
CALL WriteDMS(Alt, 4)
PRINT

PRINT INT(Az * 57.3 * 100) / 100, Alt * 57.3' $$$$$ convert from radians
IF (Alt > 0) THEN
  dAlt = AtmRefraction(Alt)
  PRINT "Altitude taking into account atmospheric refraction : ";
  CALL WriteDMS(Alt + dAlt, 4)
  PRINT
  END IF
PRINT

' Physical Ephemeris
PRINT "Physical ephemeris :"
CALL MoonPhysEphemeris(T, s, SSun, Obl, NutLon, NutObl, PhysData)
PRINT USING "Phase angle =+##.##, phase = #.###"; PhysData.i * RToD; PhysData.k
PRINT USING "Position angle of the Moon's bright limb = ###.#"; PhysData.x * RToD
PRINT "Optical libration :  l" + CHR$(34) + " =";
PRINT USING "##.###, b" + CHR$(34) + " =##.###"; PhysData.Ld * RToD; PhysData.Bd * RToD
PRINT USING "Physical libration : l' =##.###"; PhysData.Ldd * RToD;
PRINT USING ", b' =##.###"; PhysData.Bdd * RToD
PRINT USING "Total libration :    l  =##.###"; PhysData.l * RToD;
PRINT USING ", b  =##.###"; PhysData.b * RToD
PRINT USING "Position angle :###.##"; PhysData.P * RToD
PRINT



' Calculate times of Moonrise and set
T = (INT(T * 36525 + .5001 - TimeZone) + TimeZone - .5) / 36525
DTOfUT = T + DeltaT * secToT
CALL MoonPos(DTOfUT - 1 / 36525, S2)
CALL EclToEqu(S2.l, S2.b, Obl, RA1, Decl1)
CALL MoonPos(DTOfUT, S2)
CALL EclToEqu(S2.l, S2.b, Obl, RA2, Decl2)
CALL MoonPos(DTOfUT + 1 / 36525, S2)
CALL EclToEqu(S2.l, S2.b, Obl, RA3, Decl3)
CALL RiseSet(T, DeltaT, RA1, Decl1, RA2, Decl2, RA3, Decl3, MoonSetHeight(MoonParallax), ObsLon, ObsLat, RISE, Transit, Setting, RiseSetFlags)
SELECT CASE RiseSetFlags
  CASE ALWAYS.ABOVE
    PRINT "The Moon is always above the horizon.  Meridian transit at ";
    CALL WriteHMS(Transit, 2)
    PRINT
  CASE ALWAYS.BELOW
    PRINT "The Moon is always below the horizon."
  CASE 0
    PRINT "Moonrise : ";
    CALL WriteHMS(RISE, 2)
    PRINT ", transit : ";
    CALL WriteHMS(Transit, 2)
    PRINT ", Moonset : ";
    CALL WriteHMS(Setting, 2)
    PRINT

RISE2 = RISE * 3.82: Setting2 = Setting * 3.82          '$$$$$

END SELECT



GOSUB SaveVariables            '$$$$$
GOTO restart                  '$$$$$



SaveVariables:           ' $$$$$
       
          DIM Dates$(1500)
          DIM Moon(1500, 7)    '   744 per month  @ 1 hour intervals
      
' Lat Long.
' Date$
' #1=Time, #2=Topo Right Ascension, #3=Topo Declination
' #4=Geocentric Moon Dist, #7=Topocentric Moon Dist
       
  Dates$ = STR$(Date.mm) + "/" + STR$(INT(Date.dd)) + "/" + STR$(Date.yy)
  TopoMoonDist = (DistRatio1 / DistRatio2) * s.r  ' Topocentric distance
  mm% = mm% / 60
 
  nn = nn + 1
 Dates$(nn) = Dates$
 Moon(nn, 1) = H% + mm%
 Moon(nn, 2) = INT(Az * 57.3 * 100) / 100'  Azimith  (degs.east from north)
 Moon(nn, 3) = INT(Alt * 57.3 * 100) / 100'  Altitude (degs. above horizon-h)
 Moon(nn, 4) = s.r           'Geo Distance Km.
 Moon(nn, 5) = RISE2: Moon(nn, 6) = Setting2
 Moon(nn, 7) = TopoMoonDist

IF nn >= 1490 THEN PRINT "DIMENSION FULL ": GOSUB printouts: STOP
              RETURN



printouts:
CLS

 PRINT "Hardcopy or Screen printout  # of entries "; nn
 INPUT "P for Printer or S for Screen  -(F) for files "; Printout$
lines = 0

   IF Printout$ = "p" OR Printout$ = "P" THEN GOSUB HARDCOPY
   IF Printout$ = "s" OR Printout$ = "S" THEN GOSUB SCREENPRINT
   IF Printout$ = "f" OR Printout$ = "F" THEN PRINT "NOT IN YET"
  
   RETURN



HARDCOPY:
          
           'rem Use negative for approaching velocities
           '    use positive for moving away velocities

FOR nnn = 1 TO nn
IF lines <> 0 THEN 8200   'bypass

LPRINT "DOPPLER #2  Computes Earth-Moon Doppler Velocity for Synodic Analysis"
LPRINT "Program Run Date: "; DATE$
LPRINT "FOR LOCATION: LAT:"
LPRINT
LPRINT "       SOLAR  GEOCENTRIC TOPOCENTRIC"
LPRINT " DATE / TIME   DISTANCE   DISTANCE    ACCL    DOPP VEL (Km/hr)"
LPRINT
8200

lines = lines + 1
IF Moon(nnn, 1) > 0 AND Moon(nnn - 1, 1) > 0 THEN PerHour = ABS(Moon(nnn - 1, 1) - Moon(nnn, 1))' velocity divisor KM/Hour
IF PerHour = 0 THEN PerHour = 1   ' div by zero

SepVelEarthMoon.1 = Moon(nnn, 7) - Moon(nnn - 1, 7) / PerHour' - is approaching
SepVelEarthMoon.2 = Moon(nnn + 1, 7) - Moon(nnn, 7) / PerHour

  AcclEarthMoon = ABS(SepVelEarthMoon.2) - ABS(SepVelEarthMoon.1)
' rem check earth  sun doppler for above proper equations

IF lines = 1 THEN LPRINT " RISE: "; Moon(nnn, 5); "   SET: "; Moon(nnn, 6)
 LPRINT Dates$(nnn);
 LPRINT Moon(nnn, 1);    ' Time
 LPRINT TAB(19); Moon(nnn, 4);     ' geo dist
 LPRINT TAB(30); Moon(nnn, 7);   ' topo dist
 LPRINT TAB(42); AcclEarthMoon;    ' accl
 LPRINT TAB(55); SepVelEarthMoon.1  ' sep vel
 

IF lines = 41 THEN PRINT CHR$(12): lines = 0  'form feed

  NEXT nnn

  INPUT "hit enter key"; anykey$
  lines = 0
  RETURN







SCREENPRINT:
           'rem Use negative for approaching velocities
           '    use positive for moving away velocities

lines = lines + 1: IF lines > 1 THEN 9000
PRINT "DOPPLER #2  Computes Earth-Moon Doppler Velocity for Synodic Analysis"
PRINT "Program Run Date: "; DATE$
9000 :
IF lines > 1 THEN 9200 'bypass
PRINT "FOR LOCATION: LAT:"
PRINT
PRINT "       SOLAR      GEOCENTRIC TOPOCENTRIC"
PRINT " DATE / TIME       DISTANCE   DISTANCE      ACCL      DOPP VEL (Km/hr)"
PRINT
9200

FOR nnn = 1 TO nn

IF Moon(nnn, 1) > 0 AND Moon(nnn - 1, 1) > 0 THEN PerHour = ABS(Moon(nnn - 1, 1) - Moon(nnn, 1))' velocity divisor KM/Hour
IF PerHour = 0 THEN PerHour = 1   ' div by zero

SepVelEarthMoon.1 = Moon(nnn, 7) - Moon(nnn - 1, 7) / PerHour' - is approaching
SepVelEarthMoon.2 = Moon(nnn + 1, 7) - Moon(nnn, 7) / PerHour

  AcclEarthMoon = ABS(SepVelEarthMoon.2) - ABS(SepVelEarthMoon.1)
' rem check earth  sun doppler for above proper equations

  IF lines = 1 THEN PRINT " RISE: "; Moon(nnn, 5); "   SET: "; Moon(nnn, 6)
  PRINT Dates$(nnn);
  PRINT Moon(nnn, 1);    ' Time
  PRINT TAB(19); Moon(nnn, 4);     ' geo dist
  PRINT TAB(30); Moon(nnn, 7);   ' topo dist
  PRINT TAB(42); AcclEarthMoon;    ' accl
  PRINT TAB(55); SepVelEarthMoon.1  ' sep vel

lines = lines + 1
IF lines = 24 THEN lines = 1

  NEXT nnn
  lines = 0
  INPUT "hit enter key"; anykey$
 
  RETURN




SAVEFILE:
CLS : nn$ = "$$$"

PRINT " Append file removed store monthly instead."
' PRINT "SEPARATE NEXT DIMENSION FILE SAVE WITH $$$"

' PRINT " append file when dimension becomes full"
INPUT "Enter File Name Starting Date  Examp: (043095.moo) "; MoonDoppler$
IF MoonDoppler$ = "" THEN RETURN

' IF FirstFile > 0 THEN GOTO Appending
OPEN MoonDoppler$ FOR OUTPUT AS #1
GOTO WriteFile

' Appending:
' OPEN MoonDoppler$ FOR APPEND AS #1

WriteFile:
WRITE #1, nn$         ' append file separator = $$$
WRITE #1, nn
WRITE #1, SpareVariable
WRITE #1, DATE$       ' run date
WRITE #1, Latitude     ' get variable from ReadReal# routine
WRITE #1, Longitude
WRITE #1, TimeZone
WRITE #1, Elevation
FOR nnn = 1 TO nn
WRITE #1, Dates$(nnn)
WRITE #1, Moon(nnn, 1)
WRITE #1, Moon(nnn, 2)
WRITE #1, Moon(nnn, 3)
WRITE #1, Moon(nnn, 4)
WRITE #1, Moon(nnn, 5)
WRITE #1, Moon(nnn, 6)
WRITE #1, Moon(nnn, 7)
NEXT nnn
CLOSE #1

RETURN


GETFILES:

OPEN MoonDoppler$ FOR INPUT AS #1

INPUT #1, nn$
INPUT #1, nn
INPUT #1, SpareVariable
INPUT #1, RunDate$           '  how to handle appended files?
INPUT #1, Latitude
INPUT #1, Longitude
INPUT #1, TimeZone
INPUT #1, Elevation

FOR nnn = 1 TO nn
INPUT #1, Moon(nnn, 1)
INPUT #1, Moon(nnn, 2)
INPUT #1, Moon(nnn, 3)
INPUT #1, Moon(nnn, 4)
INPUT #1, Moon(nnn, 5)
INPUT #1, Moon(nnn, 6)
INPUT #1, Moon(nnn, 7)
INPUT #1, Moon(nnn, 8)
NEXT nnn

CLOSE #1
RETURN

SUB Header
CLS
LOCATE 2, 1
PRINT "                       This program contains code"
PRINT "                 Copyright (c) 1991-1994 by Jeffrey Sax"
PRINT "                 and Distributed by Willmann-Bell, Inc."
PRINT "                            Serial 076358"
PRINT
PRINT : PRINT
PRINT TAB(25); "     Moon Doppler "
PRINT TAB(25); "By Todd Walter Grigsby"
PRINT TAB(25); "version 09-12-96"
PRINT
PRINT "THIS PROGRAM WILL RUN ONLY FROM YOUR FLOPPY DRIVE (A)"
PRINT "PLEASE MOVE IT IF YOU HAVE NOT ALREADY DONE SO"
PRINT
PRINT "Program is under development, and is provided in its present state"
PRINT "only to provide an indication of synodic Doppler velocities."


PRINT
PRINT "relate velocities to dates that rf scans were taken-make new predictions"
PRINT "REQUIRES EARTH-SUN Doppler comparasons for predictions"
PRINT
PRINT "   Use Break Key to Stop"



LOCATE 25, 26
PRINT "Press any key to continue..."
WHILE INKEY$ = "": WEND
CLS
END SUB

SUB InputData
CLS

CALL ReadDate("Enter date ", Date)
Date.dd = Date.dd + ReadHMS("Enter time ") / pi2
PRINT

PRINT "Astoria Ore.  Long 124   Lat 46.2  time zone 8"
ObsLon = ReadDMS("Enter longitude (East is minus) ")
ObsLat = ReadDMS("Enter latitude ")
TimeZone = ReadReal("Enter time zone (UT - LT) in hours ") / 24
Height = ReadReal("Enter height above sea level in meters ")

END SUB

